import nltk, re, pprint

nltk.data.show_cfg('grammars/feat0.fcfg')

tokens = 'Kim likes children'.split()
from nltk.parse import load_earley
cp = load_earley('grammars/feat0.fcfg', trace=2)
trees = cp.nbest_parse(tokens)

for tree in trees: print tree

fs1 = nltk.FeatStruct(TENSE='past', NUM='sg') 
print fs1

fs1 = nltk.FeatStruct(PER=3, NUM='pl', GND='fem')
print fs1['GND']

fs1['CASE'] = 'acc'

fs2 = nltk.FeatStruct(POS='N', AGR=fs1)
print fs2

print fs2['AGR']

print fs2['AGR']['PER']

nltk.FeatStruct("[POS='N', AGR=[PER=3, NUM='pl', GND='fem']]")

person01 = nltk.FeatStruct(name='Lee', telno='01 27 86 42 96', age=33)

fs = nltk.FeatStruct("""[NAME='Lee', ADDRESS=(1)[NUMBER=74, STREET='rue Pascal'], 
                        SPOUSE=[NAME='Kim', ADDRESS->(1)]]""")
print fs

fs1 = nltk.FeatStruct("[A='a', B=(1)[C='c'], D->(1), E->(1)]")

fs2 = nltk.FeatStruct("[A=(1)[], B=(2)[], C->(1), D->(2)]")

fs1 = nltk.FeatStruct(NUMBER=74, STREET='rue Pascal')
fs2 = nltk.FeatStruct(CITY='Paris')
print fs1.unify(fs2)

print fs2.unify(fs1)

fs0 = nltk.FeatStruct(A='a')
fs1 = nltk.FeatStruct(A='b')
fs2 = fs0.unify(fs1)
print fs2

fs0 = nltk.FeatStruct("""[NAME=Lee, 
                          ADDRESS=[NUMBER=74, 
                                   STREET='rue Pascal'], 
                          SPOUSE= [NAME=Kim,
                                   ADDRESS=[NUMBER=74, 
                                            STREET='rue Pascal']]]""")

fs1 = nltk.FeatStruct("[SPOUSE = [ADDRESS = [CITY = Paris]]]")

fs2 = nltk.FeatStruct("""[NAME=Lee, ADDRESS=(1)[NUMBER=74, STREET='rue Pascal'],
                          SPOUSE=[NAME=Kim, ADDRESS->(1)]]""")

fs1 = nltk.FeatStruct("[ADDRESS1=[NUMBER=74, STREET='rue Pascal']]")
fs2 = nltk.FeatStruct("[ADDRESS1=?x, ADDRESS2=?x]")
print fs2

print fs2.unify(fs1)

nltk.data.show_cfg('grammars/feat1.fcfg')

nltk.data.show_cfg('grammars/german.fcfg')

